
<template>
    <div>
      <h2>Register Vehicle</h2>
      <form @submit.prevent="registerVehicle">
        <div>
        <label for="vehicleMark">Vehicle Mark:</label>
        <input type="text" id="vehicleMark" v-model="vehicleData.vehicleMark" required />
      </div>

      <div>
        <label for="vehiclePrice">Vehicle Price:</label>
        <input type="number" id="vehiclePrice" v-model="vehicleData.vehiclePrice" required />
      </div>

      <div>
        <select v-model="vehicleData.vehicleType" required>
        <option value="" disabled>Select Type</option>
        <option value="auto">auto</option>
        <option value="kombi">kombi</option>
        <option value="mobilehome">mobilehome</option>
        </select>
      </div>

      <div>
        <label for="rentacarobjectID">Rent A Car Object ID:</label>
        <input type="number" id="rentacarobjectID" v-model="vehicleData.rentacarobjectID" required/>
      </div>

      <div>
        <label for="consumption">Consumption:</label>
        <input type="number" id="consumption" v-model="vehicleData.consumption" required/>
      </div>

      <div>
        <select v-model="vehicleData.vehicleTransmissions" required>
        <option value="" disabled>Select Transmisson</option>
        <option value="automatik">automatik</option>
        <option value="manuelni">manuelni</option>
        </select>
      </div>

      <div>
        <select v-model="vehicleData.fuelType" required>
        <option value="" disabled>Select Fuel Type</option>
        <option value="benzin">benzin</option>
        <option value="dizel">dizel</option>
        </select>
      </div>

      <div>
        <label for="doorNumber">Door Number:</label>
        <input type="number" id="doorNumber" v-model="vehicleData.doorNumber" required/>
      </div>

      <div>
        <label for="peopleInCarNumber">People In Car Number:</label>
        <input type="number" id="peopleInCarNumber" v-model="vehicleData.peopleInCarNumber" required/>
      </div>

      <div>
        <label for="description">Description:</label>
        <textarea id="description" v-model="vehicleData.description" required></textarea>
      </div>

      <div>
      <label for="image">Vehicle Image:</label>
        <input
          type="file"
          id="image"
          accept="image/*"
          @change="handleImageUpload"
        />
      </div>

      <div>
          <select v-model="vehicleData.status" required>
          <option value="" disabled>Status </option>
          <option value="available">available</option>
          <option value="booked">booked</option>
          <option value="maintenance">maintenance</option>
          <option value="unavailable">unavailable</option>
        </select>
        </div>
      <button type="submit">Register</button>
    </form>
      <p v-if="errorMessage" class="error">{{ errorMessage }}</p>
    </div>
  </template>
  
  <script>
  import axios from 'axios';
  
  export default {
    data() {
      return {
        vehicleData: {
        id: Date.now().toString(),
        vehicleMark: '',
        vehiclePrice: 0,
        vehicleType: '',
        rentacarobjectID: 0,
        consumption: 0,
        vehicleTransmissions: '',
        fuelType: '',
        doorNumber: 0,
        peopleInCarNumber: 0,
        description: '',
        image: '',
        status: ''
      }
       ,
        errorMessage: '',
      };
    },
    methods: {
      handleImageUpload(event) {
      const file = event.target.files[0];

      if (file) {
        // konvertujem ocitanu sliku u base 64
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onloadend = () => {
          this.vehicleData.image = reader.result.split(',')[1];
        };
      }
    },
      registerVehicle() {
        // api req do bekenda
        axios.post('/api/addVehicle', this.vehicleData)
          .then((response) => {
            if (response.data.registered) {
                this.$router.push('/login');
            } else {
              this.errorMessage = 'Registration of vehicle failed. Please try again.';
            }
          })
          .catch((error) => {
            console.error('Registration of vehicle error:', error);
          });
      },
    },
  };
  </script>
  
  <style>
 
  .error {
    color: red;
  }
  </style>
  